//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
// 
using System;
using System.Threading;

namespace ProfilingSamples
{
	public class ContentionMain 
	{
		static Random r;
		private void WorkerThread()
		{
			Monitor.Enter(this);
			Thread.Sleep(r.Next(1000));
			Monitor.Exit(this);
		}
		private void TestThread()
		{
			try
			{
				while(true)
				{ 
					Thread [] t = new Thread[10];
					for(int i = 0;i < 10;i++)
					{
						t[i] = new Thread(new ThreadStart(WorkerThread));
						t[i].Start();
					}
					for(int i = 0;i < 10;i++)
					{
						t[i].Join();
					}
					Thread.Sleep(5000);
				}
			}
			catch(Exception e)
			{
				Console.WriteLine("TestThread przerywa pracę: {0}", e.Message);
			}
		}
		static void Main(string [] args)
		{
			r = new Random();
			ContentionMain m = new ContentionMain();
			Thread testThread = new Thread(new ThreadStart(m.TestThread));
			testThread.Start();
			string input = Console.ReadLine();
			testThread.Abort();
			testThread.Join();
		}
	}
}